// cCSMA.cpp: implementation of the cCSMA class.
//
//////////////////////////////////////////////////////////////////////

#include "CSMA.h"

//////////////////////////////////////////////////////////////////////
// Construction/Destruction
//////////////////////////////////////////////////////////////////////

extern	cVTime globalClock;///Our global clock!
extern	Timers gTimerManager;


cCSMA::cCSMA(short Id,FILE* fptr,macParameter macParam):cMAC(Id,fptr, macParam)
{
	pktSent=false;
	pktToSend.length_=PKTLEN;
	//tweak the following based on how energy efficient u want the mac to be. i.e. dont call it as by default it remains on
	amPower.changeDevState( e_am_on, globalClock.globalTime);
	//the following is done if we want to assume that CSMA doesnt use WU
	wuPower.changeDevState(e_wakeup_off,globalClock.globalTime);
	
}

cCSMA::~cCSMA()
{
	
}



bool cCSMA::macSend(Packet pkt){
TimerCallback* tcbPtr ;///pointer to insert timers for each node
EventInfo evInfo;


if(underwaterPhy.getDataChannelState()== e_floor ){
	underwaterPhy.PhySendData(pkt);
	Idle=false;

	}
/**
 	INFINITE QUEUE CODE CHANGES: Because most changes will occur at 
 	the node level keeping track fo the pktsDropped var in the MAC will be difficult. 
 	With an infinite queue assumption we can simplify and never drop any pakcets evers
 	-- START
 	***/
//else we see if we can buffer a single packet and send it after a backoff
 else if(Idle==true){

 	
	//	m_pktsDropped++;
	Idle=false;
 	m_currPacket=pkt;
 	//do a backoff to check the channel status after that and transmit if needed
	
 	evInfo.eType_=e_mac_timeOut;
	evInfo.nodeId_=m_myId;
	evInfo.timeLeft_= (timeTicks) (RAND_UNIFORME*MAX_PROP_DELAY*SEC_TO_TIMETICK);//random backoff within a single prop delay
	tcbPtr = new Event(evInfo);

	hdlTimeOut=gTimerManager.AddTimer(evInfo.timeLeft_, tcbPtr);//keep the handle so that you can remove it if needed	


     }
 else{//in this last case, just let the app layer attempt retransmission or use an infinite buffer. 
 		return false; //inform the upper layer that data could not be sent
 	}
/**
 	INFINITE QUEUE CODE CHANGES	-- END 	
 ***/
return true;
}



bool cCSMA::macDataRxStart(EventInfo& eventInformation, channelState initState){

//We dont do anything in CSMA itself, this is just a phy Layer occurance 
//but we might want to effect the physical layer operation?
return false;


}


bool cCSMA::macDataRxEnd(EventInfo& eventInformation, channelState nextState){

	 cMAC::macDataRxEnd( eventInformation,  nextState) ;
/*if(m_pktsReceived ==100)
	gTimerManager.flushTimerArray();//remove all array so that you can finish this soon. 
	*/		

return false;
}


bool cCSMA::macDataTxEnd(EventInfo & eventInformation, channelState initState){
TimerCallback* tcbPtr ;///pointer to insert timers for each node
EventInfo evInfo= eventInformation;

	//tweak the following based on how energy efficient u want the mac to be. 
	///amPower.changeDevState(int e_am_off, globalClock.globalTime);
	
	m_pktsSent++;


	Idle=true;//so that we can transmit again
	/****
	Traffic Model: Add a call to nodeTxEnd
	****/
	evInfo.eType_=e_tx_end;
	evInfo.nodeId_=m_myId;
	evInfo.timeLeft_= (timeTicks) (0);

	tcbPtr = new Event(evInfo);

	gTimerManager.AddTimer(evInfo.timeLeft_, tcbPtr);//this should result in NodeTransmitEnd being called 
	///Traffic model input ends
				
return false;//for now.. unless we want to creat all event anew !
}

//The Time out event
bool cCSMA::macTimerExpire(EventInfo & eventInformation){

/**
Infiinte queue changes:
implement a backoff timer. This should only happen if an app called a macSend while the medium was busy
***/
TimerCallback* tcbPtr ;///pointer to insert timers for each node
EventInfo evInfo;

if(underwaterPhy.getDataChannelState()== e_floor){
	underwaterPhy.PhySendData(m_currPacket);
	Idle=false;

	}
else{//we do a back off again
	//do a backoff to check the channel status after that and transmit if needed
	
 	evInfo.eType_=e_mac_timeOut;
	evInfo.nodeId_=m_myId;
	double tempRand=RAND_UNIFORME;
	evInfo.timeLeft_= (timeTicks) (tempRand*MAX_PROP_DELAY*SEC_TO_TIMETICK);//random backoff within a single prop delay
	tcbPtr = new Event(evInfo);
	hdlTimeOut=gTimerManager.AddTimer(evInfo.timeLeft_, tcbPtr);//keep the handle so that you can remove it if needed	


}
return false;
}


bool cCSMA::slotTime(EventInfo& eventInformation){
//again.. in CSMA this is all asynchronous
	return true;
}


//no tone for ALOHA

bool cCSMA::macToneDetected(EventInfo & eventInformation){

	OUTCON(m_myId,"cCSMA::macToneDetected","ERR- no tone should ever be sent/detected in CSMA",2);		

return false;

}
