#include "Mac.h"

extern	cVTime globalClock;///Our global clock!
extern	Timers gTimerManager;


void cMAC::printStats(){ 
		amPower.finalize();
		wuPower.finalize();
		/*
		fprintf(outFile,"===== Node %d Stats =====\n", m_myId);
		fprintf(outFile,"MAC layer statistics (Node %d):\n", m_myId);
		fprintf(outFile,"Pkts Sent \t Pkts received \t App Pkts Blocked\t  Pkts Lost (data) Pkts Lost (tone) Pkts Lost (total)\n");
		fprintf(outFile,"%d\t\t%d\t\t%d\t\t%d\t\t%d\t\t%d\n",m_pktsSent,m_pktsReceived,m_pktsDropped,m_pktsLost,m_pktsLostByTone,(m_pktsLost+m_pktsLostByTone));		
		underwaterPhy.printsStats(outFile);
		*/
		//Enable this section for all typical stats in the simulation
		
		printf("%d\t\t%d\t\t%d\t\t%d\t\t%d\t\t",m_pktsSent,m_pktsReceived,m_pktsDropped,m_pktsLost,m_pktsLostByTone);
		amPower.printTimeInStates();wuPower.printTimeInStates();	
		cout<<(globalClock.globalTime/SEC_TO_TIMETICK)<<endl;
	//	*/
	
	  //	cout<<m_pktsSent-(m_pktsLost+m_pktsLostByTone)<<" "<<m_pktsReceived<<endl;
/*
		fprintf(outFile,"Power statistics:\n", m_myId);
		amPower.printTimeInStates();
		fprintf(outFile,"=================\n\n");
	*/
	};

/*** 
RDE Event
---------
The philosphy is that phy returns a state that tells 
about the data reception ability of the physical layer.
So if the returned state is data present, then the RDE
will result in a correct data being received (if we are the dest) b/c
and RDE will definatively result in going to the floor state.

If the state is dataOverlap, then this means that there is still
more data present on the channel after the RDE occurs. 
So although we inform the transmitter that its transmission 
failed, we donot process the the RDE for any other purpose.

if the state is dataOverlapEnded, this means data has ended
but this data reception was corrupted. Again inform the transmitter
but this time also transition in your MAC based on the state machine. 

Essentially this assumes that receiver of data keep in receiving state (sleeping
if they were not the dest) until all data is cleared on the channel). 

***/

bool cMAC::macDataRxEnd(EventInfo& eventInformation, channelState initState){

	TimerCallback* tcbPtr ;///pointer to insert timers for each node
	EventInfo evInfo;

	/**
	Now we check that the data
	which ended was intended for us or not
	We only inform the transmitter if we are the intended receiver of the packet. 
	Otherwise the transmitter is not informed. 
	This way only one reportLoss event per transmission is triggered.
	CAUTION:: With broadcast, you have no way to detect this!!!!
	**/
	if(m_myId==eventInformation.packet_.destId_ ){//i.e. you are the destination. 
		/**
		Now check the stat of phy
		before this event occured
		**/
		if(e_dataOverlap == initState ||
		e_dataOverlapEnded== initState){//in all of these cases we inform the data src that its tx failed due to a data corruption
			m_pktsCollided++;
			/************************
			Informing the sender node that 
			its transmission failed due to data
			collision
			***************************/
			evInfo.eType_=e_abstract_reportLoss;
			evInfo.nodeId_=eventInformation.packet_.sourceId_;

			evInfo.timeLeft_= (timeTicks)0;

			tcbPtr = new Event(evInfo);

			gTimerManager.AddTimer(evInfo.timeLeft_, tcbPtr);
							
			/************************/
			if(e_dataOverlap==initState)//in this case we dont let the MAC process the event
				return false;
				
		}
		else if(e_dataToneOverlap ==initState){
			m_pktsCollidedByTone++;
			/************************
			Informing the sender node that 
			its transmission failed due to data
			collision
			***************************/
		
			evInfo.eType_=e_abstract_reportLossByTone;
			evInfo.nodeId_=eventInformation.packet_.sourceId_;

			evInfo.timeLeft_= (timeTicks)0;

			tcbPtr = new Event(evInfo);

			gTimerManager.AddTimer(evInfo.timeLeft_, tcbPtr);//keep the handle so that you can remove it if needed	
		
			/************************/
		}
		else if(e_dataPresent==initState){ //a successfull data reception (and ur the destination)
			m_pktsReceived++;
		}
		else{
			OUTCON(m_myId,"macDataRxEnd","PHY LAYER ERROR, no RDE without a RDS !!",2);		
		}
				
	}
	else{//when ur not the destination u still dont want the RDE event to be processed until and unless all data has finished. 
		if(e_dataOverlap==initState)//in this case we dont let the MAC process the event
				return false;
	}
	return true;
}
