// cSTLohi.cpp: implementation of the cSTLohi class.
//
//////////////////////////////////////////////////////////////////////

#include "STLohi.h"

//////////////////////////////////////////////////////////////////////
// Construction/Destruction
//////////////////////////////////////////////////////////////////////

extern	cVTime globalClock;///Our global clock!
extern	Timers gTimerManager;


int BackOffSlot(int fcc, bool didContend,double spatFairnessIndex, short  framesSinceFC){//this function calculates the bkoff based on congestion information and priority status
	int retVal;

	float randVal=RAND_UNIFORME+spatFairnessIndex;

	if(didContend){
	/*	fcc-=framesSinceFC;//think about using it, but for now leave it.. one case is that when there is nothing
						//send, the fcc=1 will result in it still sending something.
		if(fcc<1)
			fcc=1;
			
*/
		retVal= (int)( (randVal)* fcc);
		
		}
	else
		retVal= (int)((randVal)*pow(2,(double)fcc));
		
//	cout<<"fcc="<<fcc<<" didCntd= "<<didContend<<"SFI= "<<spatFairnessIndex<<" randVal= "<<randVal<<endl;
	
	return retVal;
}
	
cSTLohi::cSTLohi(short Id,FILE* fptr,macParameter macParam):cMAC(Id,fptr, macParam)
{
	m_contendCount=m_firstCntdCount=0;
	m_slotLeft=0;
	dataCollided=dataCollidedByTone=false;
	hasDeafNeighbor=false;
	didCntd=false;
	m_pktsCollided=m_pktsCollidedByTone=m_pktsReceived=m_pktsDropped=m_pktsSent=m_extraSlot=0;
	lastSlotStartTime=0;
	m_framesSinceFC=0;
	
	//PSLOT_TIME = (double)(MAX_PROP_DELAY+TONE_DURATION);//the nodes are syn to multiple of this time, only 1 tone duration as there is no desyncing
	PSLOT_TIME =m_macParam.fracDelay*(double)MAX_PROP_DELAY;// this changes so that we can verify the behavior of ST-Lohi under different delays
	DESYNC_DURATION = 2*TONE_DURATION;//this allows complete reception of tone within the deaf zone if you choose the second slot
	INIT_SLOT_SYNC=5;
}

cSTLohi::~cSTLohi()
{
	
}

bool cSTLohi::initSlotTime(){

	TimerCallback* tcbPtr ;///pointer to insert timers for each node
	EventInfo evInfo;

		
	evInfo.eType_=e_mac_slotTime;
	evInfo.nodeId_=m_myId;				
			
	evInfo.timeLeft_= (timeTicks) (INIT_SLOT_SYNC);
	
	tcbPtr = new Event(evInfo);	
	gTimerManager.AddTimer(evInfo.timeLeft_, tcbPtr);

	return true;
}
//the send signal in the state machine. 
bool cSTLohi::macSend(Packet pkt){

char buff [40];

	if(Idle){//when the mac can handle transmission
		m_currPacket=pkt;
		
		switch(m_macState){//handle this event in the state machine
			case e_mac_idle:

				startBufferTime=globalClock.globalTime;//TAG:latencymeasure

				
				//////////////////////////////
				//Intelligent Bkoff changes - IBC /
				/////////////////////////////
				if(m_firstCntdCount<0)
					m_firstCntdCount=0;
				//for avg slot test
				//cout<<"start "<<globalClock.globalTime/SEC_TO_TIMETICK<<endl;
				
				//Now we decide on a back off slot duration based on the FCC
				
				m_slotLeft= BackOffSlot(m_firstCntdCount, didCntd,0,m_framesSinceFC)+1+m_extraSlot;//the +1 for the next slot time			
				
				Idle=false; //make sure u can no longer take another application layer packet				

				m_macState=e_mac_contend_backoff;
				sprintf(buff,"send->idle slotChosen=%d ",m_slotLeft);

				OUTCON(m_myId,buff,"Defering reservation attempt- bkoff",3);
				//////////////////////////////
				//Intelligent Bkoff changes - IBC /
				/////////////////////////////
					
				OUTFILE(outFile,m_myId, "send->idle", "",3);
				break;
			case e_mac_contend_backoff:
				
				OUTFILE(outFile,m_myId,"send->backoff", "shouldnt happen",2);
				break;
			case e_mac_contention:
				
				OUTFILE(outFile,m_myId,"send->contention", "shouldnt happen",2);
				break;
			case e_mac_anticipating:
				startBufferTime=globalClock.globalTime;//TAG:latencymeasure

				
				//just make sure you update ur blocking nature
				Idle=false;
				//keep ur state
				m_macState=e_mac_anticipating;
				OUTCON(m_myId,"send->anticipating", "Now transition to  blocking state",3);
				OUTFILE(outFile,m_myId, "send->anticipating", "",3);
				break;
			case e_mac_transmitting:
				
				OUTFILE(outFile,m_myId, "send->transmitting", "Error.. should not happen",2);
				break;
			case e_mac_receiving:
				startBufferTime=globalClock.globalTime;//TAG:latencymeasure

				
				//just make sure you update ur blocking nature
				Idle=false;
				//keep ur state
				m_macState=e_mac_receiving;
				OUTCON(m_myId,"send->receiving", "Now transition to  blocking state",3);
				OUTFILE(outFile,m_myId, "send->receiving", "",3);
				break;
			case e_mac_wait_data:
				startBufferTime=globalClock.globalTime;//TAG:latencymeasure

				
				//just make sure you update ur blocking nature
				Idle=false;
				//keep ur state
				m_macState=e_mac_wait_data;
				OUTCON(m_myId,"send->wait_data", "Now transition to  blocking state",3);
				OUTFILE(outFile,m_myId, "send->wait_data","",3);
				break;
			case e_mac_wait_slot:
				
				OUTFILE(outFile,m_myId, "send->wait_slot", "shouldnt happen",2);
				break;
			case e_mac_wait_desync:
				
				OUTFILE(outFile,m_myId, "send->wait_desync", "shouldnt happen",2);
				break;

			default:
				OUTFILE(outFile,m_myId, "send->UNKNOWN STATE", "",3);
				break;
			
			}		
		
		return true;
		
	}
	else{
		m_pktsDropped++;
		return false; //inform the upper layer that data could not be sent
	}
}
/* // phyinterfaceUPDATE
bool cSTLohi::macToneRxStart(EventInfo& eventInformation) {
//this event should go directly to the Phy
//This is not at all noticed by the MAC.. present here due to a kludge in the code
underwaterPhy.PhyToneRxStart(eventInformation);
//also if we had MAC in a receiving state its data might get corrupted so we set the appropriate 
//variable.
if(m_macState==e_mac_receiving)
	dataCollidedByTone=true;

return false;

}

*/

//RTE a valid tone detected on phy layer

/*****
phyinterfaceUPDATE
-----------------
//bool cSTLohi::macToneRxEnd(EventInfo & eventInformation){
****/
bool cSTLohi::macToneDetected(EventInfo & eventInformation){

//first a sanity flag check i.e. is the tone rx actually on at this time, and has it been on long enough!
if(wuPower.currentState !=e_wakeup_rx ){

	if(wuPower.currentState !=e_wakeup_on ){	
	OUTCON(m_myId,"Tone Detected while not in RX mode","NOT IN ON/LISTEN EITHER!!! POWER CNTRL ERR",2);
	}
	else{
	OUTCON(m_myId,"Tone Detected while not in RX mode","BUT IN ON/LISTEN STATE: confirm why",2);
	}
}
else{	//now we check how long it has been in this state
timeTicks timeInDetectState;
	timeInDetectState= (globalClock.globalTime- wuPower.stateStartTime);
	if(timeInDetectState < (timeTicks)(TONE_DETECT_TIME*SEC_TO_TIMETICK)){
		OUTCON(m_myId,"Tone Detected","WU hasnt stayed in rx mode long enough!!!PWR CNTRL ERR",2);		
	}
/*	else
		cout<<timeInDetectState<<endl;*/
}
/******************
no need to do any kludgy stuff now that the phy layer takes 
//care of all possible collision and non-events
//So if this event is happening, you really did have the 
 tone on the channel for long enough to be detected!!!

 However we do have to account for our data transfer
 strategy which requires that we turn on our data
 receiver for enough time that we can lock in the start symbol
i.e.  CHK_DATA_TIME.
Since we KNOW that this is a contention tone, we can be sure 
that the AM device will turn off after the that wait time
 *******************/
 timeTicks currentTime=globalClock.globalTime;
amPower.changeDevState(e_am_rx, currentTime);
//now go into the future to change it back to the off state
amPower.changeDevState(e_am_off, currentTime+(timeTicks)(CHK_DATA_TIME*SEC_TO_TIMETICK));


switch(m_macState){//handle this event in the state machine
		case e_mac_idle:

			m_contendCount=1;
			m_macState=e_mac_anticipating;//change state 
			OUTCON(m_myId,"RTE->idle","transition to anticipating",3);
			OUTFILE(outFile,m_myId, "RTE->idle", "",3);
			break;
		case e_mac_contend_backoff:

			m_contendCount=1;
			//Intelligent Bkoff changes - IBC /
			/*	if(false==didCntd)// this means this is the first contention slot after the last data got through
				//Also we have never attempted so we dont get any higher priority -
				m_firstCntdCount=0;//reset should update the FCC based on the data attempt
				*/
				//Intelligent Bkoff changes - IBC /
				
			m_macState=e_mac_anticipating;//change state 
			Idle=false; //just to make sure u make the correct transition in the anticipating state
			OUTCON(m_myId,"RTE->contend_backoff","transition to anticipating",3);
			OUTFILE(outFile,m_myId,"RTE->backoff", "",3);
			break;
		case e_mac_contention:
			m_contendCount++;///increment your count of the # of contenders
			m_macState=e_mac_contention;//keep the state
			OUTCON(m_myId,"RTE->contention","we share contention with another",3);
			OUTFILE(outFile,m_myId,"RTE->contention", "another contender!",3);
			break;
		case e_mac_anticipating:
			m_contendCount++;///increment your count of the # of contenders
			m_macState=e_mac_anticipating;//keep the state
			OUTCON(m_myId,"RTE->anticipating","another contender..",4);
			OUTFILE(outFile,m_myId, "RTE->anticipating", "",3);
			break;
		case e_mac_transmitting:
			
			OUTFILE(outFile,m_myId, "RTE->transmitting", "Can cause collision of data at a receiver",3);
			break;
		case e_mac_receiving:
			OUTCON(m_myId, "RTE->receiving", "error- unless ortho tone/data channels",3);			
			OUTFILE(outFile,m_myId, "RTE->receiving", "error- unless ortho tone/data channels",3);	
			break;
		case e_mac_wait_data:
			
			OUTFILE(outFile,m_myId, "RTE->wait_data", "",3);
			break;
		case e_mac_wait_slot:
			
			m_macState=e_mac_anticipating;//change state 
			m_contendCount=1;
			Idle=false; //just to make sure u make the correct transition in the anticipating state
			OUTCON(m_myId,"RTE->wait_slot","transition to anticipating",3);
			OUTFILE(outFile,m_myId, "RTE->wait_slot", "",3);
			break;
		case e_mac_wait_desync:
			
			OUTFILE(outFile,m_myId, "RTE->wait_desync", "This shouldnt happen with desync interval < 2 Tone length",2);
			break;

		default:
			OUTFILE(outFile,m_myId, "RTE->UNKNOWN STATE", "",3);
			break;
}
return false;

}

/* // phyinterfaceUPDATE

bool cSTLohi::macToneTxEnd(EventInfo& eventInformation){
timeTicks duration;

//update the power status to have transmitted the tone
wuPower.consumeEnergy(e_wakeup_tx, (timeTicks) (TONE_DURATION*SEC_TO_TIMETICK));
duration =globalClock.globalTime-underwaterPhy.phyToneTxEnds();///this should be directly targeted to the phy layer. should not be a concern of MAC
////
In order to handle the case where we are the destination of
a data pkt that got corrupted by our transmission (as opposed
to being stomped on by another tone reception!)
I need to set datcollbytone=true
///
if(m_macState==e_mac_receiving)
	dataCollidedByTone=true;
return false;
}
*/

/**********
RDS	event:
The way this is made to work is that
MAC is first made to look at the channel state provided by the physical layer. 
Now only if the physical state was clear (e_floor state)
that we can actually read the data header. 
However, with a tone being present, although the data header gets corrupted,
we still transit to a data reciving state assuming that the data wasnt for us. 
In case a data was present (in any form) we dont allow the MAC to process the
data reception (as it should'nt be construed as a different packet, in this case
the new data will simply corrupt bytes of an existing transmission). 
***********/
bool cSTLohi::macDataRxStart(EventInfo& eventInformation, channelState initState){
bool isDestination=false;


if (e_dataOverlap == initState||
	e_dataPresent== initState||
	e_dataToneOverlap== initState){ //i.e. we should not be able to detect this data reception at all
	return false;

}
else if(e_floor== initState||
		( (e_tonePresent ==initState ||e_toneOverlap==initState ) &&
		m_macParam.isToneDataOrthognal==true) ){//only in these cases we can correctly receive a data and its header
	
	/**
	Since the data pkt actually has a tone before it,
	we first set up a tone power consumtion (a)
	then (b) we turn on the am receiver.
	**/
	timeTicks toneEndTime = (globalClock.globalTime+(timeTicks)TONE_DURATION*SEC_TO_TIMETICK);
	//a)
	if(wuPower.currentState == e_wakeup_off){//Sanity flags
		OUTCON(m_myId,"macDataRxStart","WU is OFF while receiving for data !!!PWR CNTRL ERR",2);		
	}
	wuPower.changeDevState(e_wakeup_rx, globalClock.globalTime);

	//I removed the line below as it is not in line with a running assumption that WU takes same energy when it is ON
	// and there is tone OR data present on the channel. i.e. it doesnt go to idle power consumption when data is present
	//as it will be in this case.
	//wuPower.changeDevState(e_wakeup_on,toneEndTime);//turn it back to idle state after the TONE_DURATION  TIME
	//b)
	amPower.changeDevState(e_am_rx,toneEndTime);//turn am to receive state after the TONE_DURATION  TIME
					
	


	if(m_myId==eventInformation.packet_.destId_ ||
		-1==eventInformation.packet_.destId_ ){		
		isDestination=true;
		rxPkt.urDestination=true;
		rxPkt.endOfPktReception = globalClock.globalTime +  (timeTicks)((eventInformation.packet_.length_ /CHANNEL_DATA_RATE)*SEC_TO_TIMETICK);
		}
	else{//in this case we should turn off the data rx after reading the header
	
	amPower.changeDevState(e_am_off,
		(toneEndTime+(timeTicks) (READ_HEADER_TIME*SEC_TO_TIMETICK) ));//turn it back to  off state after the reading the header

	}
}	
//otherwise since we cant read the header when some energy is on the phy
//layer behave as if the data packet is not meant for u (even if it was)
fairnessBkoff= 1-(double)((globalClock.globalTime-lastSlotStartTime)/(PSLOT_TIME*SEC_TO_TIMETICK));

switch(m_macState){//handle this event in the state machine
		case e_mac_idle:
			OUTFILE(outFile,m_myId, "RDS->idle", "shouldnt happen",2);
			break;
			/**
			NOTE:
				receiving data in any of the 4 states of wait_desync, 
				contend bkoff, contention and anticipating results in 
				the same action i.e. immediately set state for being receiving!
			**/
		case e_mac_contend_backoff:
			if(isDestination){
				m_macState=e_mac_receiving;
				
				//we consume the energy over here.. as we stay up for as long as the pkt len of this first packet states
				//I also subtract the energy already accounted for reading the packet header to be consistent
//				amPower.consumeEnergy(e_am_rx, (timeTicks)( ((eventInformation.packet_.length_ /CHANNEL_DATA_RATE)-READ_HEADER_TIME)*SEC_TO_TIMETICK));
				
				OUTCON(m_myId,  "RDS->contend_backoff", "data receiving as dest",3);				
			}
			else{
				m_macState=e_mac_wait_data;				
				OUTCON(m_myId,  "RDS->contend_backoff", "data receiving but not dest",4);	
			}			
				
			Idle=false;
			//also check the status of FCC
			if(m_firstCntdCount<2)
				m_firstCntdCount=2;//just to make sense--- data will only happen due to deafness, so there have to be two nodes contending minimum
			
			OUTFILE(outFile,m_myId,"RDS->backoff", "",3);
			break;
		case e_mac_contention:
			Idle=false;//make sure that the transition keeps the blocking state in tact
			didCntd=true;// also this is essential
			if(isDestination){				
				m_macState=e_mac_receiving;//else receive the pkts
				//we consume the energy over here.. as we stay up for as long as the pkt len of this first packet states
				//I also subtract the energy already accounted for reading the packet header to be consistent
//				amPower.consumeEnergy(e_am_rx, (timeTicks)( ((eventInformation.packet_.length_ /CHANNEL_DATA_RATE)-READ_HEADER_TIME)*SEC_TO_TIMETICK));
				
				OUTCON(m_myId,"RDS->contention", "as destination..now rxing",3);
			}
			else{
				m_macState=e_mac_wait_data;///the sleep mode
				OUTCON(m_myId,"RDS->contention", "not dest...sleeping",4);
			}
			
			//also check the status of FCC
			if(m_firstCntdCount<2)
				m_firstCntdCount=2;//just to make sense--- data will only happen due to deafness, so there have to be two nodes contending minimum
			
			OUTFILE(outFile,m_myId,"RDS->contention", "",3);
			break;
		case e_mac_anticipating:
			if(isDestination){				
				m_macState=e_mac_receiving;//else receive the pkts
				//we consume the energy over here.. as we stay up for as long as the pkt len of this first packet states
				//I also subtract the energy already accounted for reading the packet header to be consistent
//				amPower.consumeEnergy(e_am_rx, (timeTicks)( ((eventInformation.packet_.length_ /CHANNEL_DATA_RATE)-READ_HEADER_TIME)*SEC_TO_TIMETICK));
				
				OUTCON(m_myId,"RDS->anticipating", "as destination..now rxing",3);
			}
			else{
				m_macState=e_mac_wait_data;///the sleep mode				
				OUTCON(m_myId,"RDS->anticipating", "not dest...sleeping",4)
			}
			
			OUTFILE(outFile,m_myId, "RDS->anticipating", "",3);
			break;
		case e_mac_transmitting:
			
			OUTFILE(outFile,m_myId, "RDS->transmitting", "shouldnt happen",2);
			break;
		case e_mac_receiving:
			/* // phyinterfaceUPDATE
			dataCollided=true;

			*/
			OUTFILE(outFile,m_myId, "RDS->receiving", "data corruption b/c of data",2);
			break;
		case e_mac_wait_data:
			
			OUTFILE(outFile,m_myId, "RDS->wait_data","shouldnt happen",2);
			break;
		case e_mac_wait_slot:
			
			OUTFILE(outFile,m_myId, "RDS->wait_slot", "shouldnt happen",2);
			break;
		case e_mac_wait_desync:
			//first.. if we get this we know we have at least some neighbor who is deaf to us - but we cant count between them
			hasDeafNeighbor=true;
			//now we remove the timer event that would have triggered data transmission. 
			gTimerManager.RemoveTimer(hdlTimeOut);
			OUTCON(m_myId,  "RDS->wait_desync", "===We have detected a Deaf neighbor===",3);				
			//now based on the data pks destination decide your next state
			if(isDestination){
				m_macState=e_mac_receiving;
				//we consume the energy over here.. as we stay up for as long as the pkt len of this first packet states
				//I also subtract the energy already accounted for reading the packet header to be consistent
//				amPower.consumeEnergy(e_am_rx, (timeTicks)( ((eventInformation.packet_.length_ /CHANNEL_DATA_RATE)-READ_HEADER_TIME)*SEC_TO_TIMETICK));
				
				OUTCON(m_myId,  "RDS->wait_desync", "data receiving as dest",3);				
			}
			else{
				m_macState=e_mac_wait_data;				
				OUTCON(m_myId,  "RDS->wait_desync", "data receiving but not dest",4);	
			}			
				
			Idle=false;
			//also check the status of FCC
			if(m_firstCntdCount<2)
				m_firstCntdCount=2;//just to make sense--- data will only happen due to deafness, so there have to be two nodes contending minimum
			
			OUTFILE(outFile,m_myId, "RDS->wait_desync", "Deaf neighbor detected",3);
			break;

		default:
			OUTFILE(outFile,m_myId, "RDS->UNKNOWN STATE", "",3);
			break;
}
return false;//for now.. unless we want to creat all event anew !


}

/*** 
RDE Event
---------
Read Base class implementation for design insight

Essentially this assumes that receiver of data keep in receiving state (sleeping
if they were not the dest) until all data is cleared on the channel). 

***/
bool cSTLohi::macDataRxEnd(EventInfo& eventInformation, channelState nextState){

/***
The idea over here is that we are trying to replicate the behavior of real radios when collisions occur.
So when a radio does get a packet, it will hook on and receive it based on the packet length (PLEN)
provided (hopefully ) in the pkt header. 

Once that PLEN bytes have been received, it will turn off its receiving mechanism. 

However, if there is a data overlap, then even after PLEN bytes, there is data on the channel. 
Ideally we would have nodes transit when PLEN bytes have been received. However, since the orignal
state m/c didnt have this provision, we are using a hack that allows us to keep the same state m/c and
transit only when all the data on the channel has finished. 

The hack is that we assume that once PLEN bytes have been received, nodes that have pkts to send
or not go to a state where they constantly poll the channel to be clear of data. Once it is cleared of data 
i.e. after the RDE that doesnt return false from cMAC::macDataRxEnd(), we transit to the idle or contend
state as described in our state machines.

Now the first part of hack is where we look at whether we are the destination of the currently synced pkt
and whether the RDE is for that pkt. 
The reason we only do this is b/c the only reason we want to know if the pkt we synced to has ended,
given the above hack/assumption, is that we want to turn off the AM to off state. If we are not the dest
then we shouldnt have it turned on any way. 

	***/
if(rxPkt.urDestination == true  && rxPkt.endOfPktReception== globalClock.globalTime){

			if(amPower.currentState == e_am_rx) //only turn off while receiving
				underwaterPhy.amOff(globalClock.globalTime);
			else
				OUTCON(m_myId, "RDE->receiving_busy", "AM not in RX mode! POWER CONTROL ERR",2);
			
			rxPkt.urDestination= false;//make it false so that we dont repeatedly turn amOff. 
	}

if(cMAC::macDataRxEnd( eventInformation,  nextState) == false)//this basically tells if the data has finished on the channel or not
		return false;

	
//otherwise we process the RDE event as a state machine transition.
if(didCntd)
	m_framesSinceFC++;
switch(m_macState){//handle this event in the state machine
			case e_mac_idle:
				
				//this might happen when the RDE is actually an end of data  resulting b/c of a tx data and receive data overlap
				if(e_dataOverlapEnded !=nextState ){
					OUTFILE(outFile,m_myId, "RDE->idle", "incorrect protocol behavior !!",2);
				}
				else{//do nothing and stay in the same state (as this is really implying that the data channel is now clear- this should be rx at MAC at all)
					m_macState= e_mac_idle;
				}
				break;
			case e_mac_contend_backoff:
				
				//this might happen when the RDE is actually an end of data  resulting b/c of a tx data and receive data overlap
				if(e_dataOverlapEnded !=nextState ){
					OUTCON(m_myId,  "RDE->contend_backoff", "incorrect protocol behavior !!",2);
				}
				else{//do nothing and stay in the same state (as this is really implying that the data channel is now clear- this should be rx at MAC at all)
					m_macState= e_mac_contend_backoff;
				}
				break;
			case e_mac_contention:
				
				OUTFILE(outFile,m_myId,"RDE->contention", "shouldnt happen",2);
				break;
			case e_mac_anticipating:
				
				OUTFILE(outFile,m_myId, "RDE->anticipating", "shouldnt happen",2);
				break;
			case e_mac_transmitting:
				
				OUTFILE(outFile,m_myId, "RDE->transmitting", "shouldnt happen",2);
				break;
			case e_mac_receiving:
				m_contendCount=0;
				m_slotLeft=0;

			
				//also turn on the wu hardware
				underwaterPhy.wakeUpOn(globalClock.globalTime);

				/*
				==========================================
				Now that data is completely received.. go to the correct state
				==========================================
				*/
				if(Idle==true){
					m_macState=e_mac_idle;
					m_contendCount=0;

				//Intelligent Bkoff changes - IBC /
					m_firstCntdCount--;
				//Intelligent Bkoff changes - IBC /

					m_slotLeft=0;
					OUTCON(m_myId, "RDE->receiving", "going to idle",3);
				}
				else{//this means u have data to send
				//now we decide on preference based on having previously contended or not

				//for avg slot test
				//cout<<"start "<<globalClock.globalTime/SEC_TO_TIMETICK<<endl;
				
				//////////////////////////////
				//Intelligent Bkoff changes - IBC /
				/////////////////////////////
				m_firstCntdCount--;//from the initial contenders one left.
				//Now we decide on a back off slot duration based on the FCC
				m_slotLeft= BackOffSlot(m_firstCntdCount, didCntd,fairnessBkoff,m_framesSinceFC)+1;//the +1 for the next slot time	

				//////////////////////////////
				//Intelligent Bkoff changes - IBC /
				/////////////////////////////
				
				OUTCON(m_myId, "RDE->receiving", "backing off",3);

				//now we transit to the bkoff state
				m_macState=e_mac_contend_backoff;
				}
				

				break;
			case e_mac_wait_data:
				
				m_slotLeft=0;
				//also turn on the wu hardware so that we can receive any other contention tones
				underwaterPhy.wakeUpOn(globalClock.globalTime);
				
				if(Idle==true){
					m_macState=e_mac_idle;
					m_contendCount=0;
					//Intelligent Bkoff changes - IBC /
					m_firstCntdCount--;
					//Intelligent Bkoff changes - IBC /
					m_slotLeft=0;
					OUTCON(m_myId, "RDE->wait_data", "going to idle",3);
				}
				else{//this means u have data to send

				//for avg slot test
				//cout<<"start "<<globalClock.globalTime/SEC_TO_TIMETICK<<endl;
					//////////////////////////////
				//Intelligent Bkoff changes - IBC /
				/////////////////////////////
				m_firstCntdCount--;//from the initial contenders one left. 
				
				//Now we decide on a back off slot duration based on the FCC
				m_slotLeft= BackOffSlot(m_firstCntdCount, didCntd,fairnessBkoff,m_framesSinceFC)+1;//the +1 for the next slot time	

				//////////////////////////////
				//Intelligent Bkoff changes - IBC /
				/////////////////////////////
				OUTCON(m_myId, "RDE->wait_data", "backing off",3);
				//now we transit to the bkoff state
				m_macState=e_mac_contend_backoff;
				}
				break;
			case e_mac_wait_slot:
				
				OUTFILE(outFile,m_myId, "RDE->wait_slot", "shouldnt happen",2);
				break;
			case e_mac_wait_desync:
				
				OUTFILE(outFile,m_myId, "RDE->wait_desync", "shouldnt happen",2);
				break;

			default:
				OUTFILE(outFile,m_myId, "RDE->UNKNOWN STATE", "",3);
				break;
	}
return false;//for now.. unless we want to creat all event anew !
}


/*** 
TDE Event
---------
When transmission ends, right now
we dont do anything at all. We consider
everything to be perfect, and simply transit to 
the idle state.

However, we should check the channel status once we attempt again (from the idle
state) and make sure that we dont send while the channel is bad

***/
bool cSTLohi::macDataTxEnd(EventInfo & eventInformation, channelState initState){
TimerCallback* tcbPtr ;///pointer to insert timers for each node
EventInfo evInfo= eventInformation;

//cout<<"end "<<m_myId<<" "<<(globalClock.globalTime)/SEC_TO_TIMETICK<<" x"<<endl;	

totalLatency+=globalClock.globalTime-startBufferTime;
switch(m_macState){//handle this event in the state machine
			case e_mac_idle:
				OUTFILE(outFile,m_myId, "TDE->idle", "shouldnt happen",2);
				break;
			case e_mac_contend_backoff:
				
				OUTFILE(outFile,m_myId,"TDE->backoff", "shouldnt happen",2);
				break;
			case e_mac_contention:
				
				OUTFILE(outFile,m_myId,"TDE->contention", "shouldnt happen",2);
				break;
			case e_mac_anticipating:
				
				OUTFILE(outFile,m_myId, "TDE->anticipating", "shouldnt happen",2);
				break;
			case e_mac_transmitting:
				Idle=true;//finally.. we can unset our busy status
				didCntd=false;
				m_framesSinceFC=0;
				m_slotLeft=0;//reset this as well.
				m_pktsSent++;//increment this count
				m_macState=e_mac_idle;//go to the idle state

			//////////////////////////////
				//Intelligent Bkoff changes - IBC /
				/////////////////////////////
				if(m_firstCntdCount>0)
					m_firstCntdCount--;
				m_extraSlot=1;
				//////////////////////////////
				//Intelligent Bkoff changes - IBC /
				/////////////////////////////

				
				/****
				Traffic Model: Add a call to nodeTxEnd
				****/
				evInfo.eType_=e_tx_end;
				evInfo.nodeId_=m_myId;
				evInfo.timeLeft_= (timeTicks) (0);

				tcbPtr = new Event(evInfo);

				gTimerManager.AddTimer(evInfo.timeLeft_, tcbPtr);//this should result in NodeTransmitEnd being called 
				///Traffic model input ends


				//once we have transmitted, surely turn OFF the am modem b/c we dont want to listen to any data what so ever
				underwaterPhy.amOff(globalClock.globalTime);
				//also turn on the wakeup receiver
				underwaterPhy.wakeUpOn(globalClock.globalTime);
				
				OUTCON(m_myId, "TDE->transmitting", "Finished transmitting",3);				
				OUTFILE(outFile,m_myId, "TDE->transmitting", "",3);
				break;
			case e_mac_receiving:
				
				OUTFILE(outFile,m_myId, "TDE->receiving", "shouldnt happen",2);
				break;
			case e_mac_wait_data:
				
				OUTFILE(outFile,m_myId, "TDE->wait_data", "shouldnt happen",2);
				break;
			case e_mac_wait_slot:
				
				OUTFILE(outFile,m_myId, "TDE->wait_slot", "shouldnt happen",2);
				break;
			case e_mac_wait_desync:
				
				OUTFILE(outFile,m_myId, "TDE->wait_desync", "shouldnt happen",2);
				break;

			default:
				OUTFILE(outFile,m_myId, "TDE->UNKNOWN STATE", "",3);
				break;
	}

return false;//for now.. unless we want to creat all event anew !
}

//The Time out event
bool cSTLohi::macTimerExpire(EventInfo & eventInformation){

if(eventInformation.eType_==e_mac_slotTime)
	return slotTime(eventInformation);//since the ST event is just a special type of timer!
switch(m_macState){//handle this event in the state machine
			case e_mac_idle:
				OUTFILE(outFile,m_myId, "TO->idle", "",3);
				break;
			case e_mac_contend_backoff:
				
				OUTFILE(outFile,m_myId,"TO->backoff", "",3);
				break;
			case e_mac_contention:
				
				OUTFILE(outFile,m_myId,"TO->contention", "",3);
				break;
			case e_mac_anticipating:
				
				OUTFILE(outFile,m_myId, "TO->anticipating", "",3);
				break;
			case e_mac_transmitting:
				
				OUTFILE(outFile,m_myId, "TO->transmitting", "",3);
				break;
			case e_mac_receiving:
				
				OUTFILE(outFile,m_myId, "TO->receiving", "",3);
				break;
			case e_mac_wait_data:
				
				OUTFILE(outFile,m_myId, "TO->wait_data", "",3);
				break;
			case e_mac_wait_slot:
				
				OUTFILE(outFile,m_myId, "TO->wait_slot", "",3);
				break;
			case e_mac_wait_desync:
				//only this state should handle TIMEOUTS
				//this meas we have reached our data tranmission slot w/o hearing another data.... so transmit now
				
				
				m_macState=e_mac_transmitting;
				underwaterPhy.PhySendData(m_currPacket);//send the current packet						
				/*
				the power of pkt tx is updated inside the phy layer
				However since the pkt is longer by the tone tx we have to:
				a) reduce the am.tx time by that amount
				b) add wu.tx cost
				*/
				//a)
				amPower.changeDevState(e_am_off,globalClock.globalTime);//turn it off as starters
				amPower.changeDevState(e_am_tx,(globalClock.globalTime+
					(timeTicks)TONE_DURATION*SEC_TO_TIMETICK));//then turn it on at the correct time in the future
				//b)
				wuPower.changeDevState(e_wakeup_tx,globalClock.globalTime);//turn it to tx state 
				wuPower.changeDevState(e_wakeup_on, (globalClock.globalTime+
					(timeTicks)TONE_DURATION*SEC_TO_TIMETICK));//turn it to idle state at the correct time


				
				m_contendCount=0;			
				
				OUTCON(m_myId,"TO->wait_desync", "desync succesfull.. ==transmitting==",3);	
				OUTFILE(outFile,m_myId, "TO->wait_desync", "Valid Time out",3);
				break;
			default:
				OUTFILE(outFile,m_myId, "TO->UNKNOWN STATE", "",3);
				break;
	}

return false;
}

//ST event 
/**
The key idea here is that a lot of backoff
is done in multiple of slot times. 
So every time a ST event occurs, if ur 
in a state i.e. anticipating, you decrement a count
in this case slotLeft, until the count reaches zero where u 
execute ur backoff behavior
**/
bool cSTLohi::slotTime(EventInfo& eventInformation){
TimerCallback* tcbPtr;///pointer to insert timers for each node
EventInfo evInfo;
char str[20];
sprintf(str,"ST event with FCC=%d",m_firstCntdCount);
OUTCON(m_myId,str, "------",3);
m_extraSlot=0;
lastSlotStartTime=globalClock.globalTime;
switch(m_macState){//handle this event in the state machine
			case e_mac_idle:
				//stay in the same state
				m_macState=e_mac_idle;
				OUTCON(m_myId, "ST->idle", "",5);
				break;
			case e_mac_contend_backoff:
				m_slotLeft--;
				if(m_firstCntdCount<m_contendCount)//this tracks the current highest value of contenders
						m_firstCntdCount=m_contendCount;
				
				if(0==m_slotLeft){//back off ends
					channelState phyState= underwaterPhy.getDataChannelState();
				/******* 
				phyInterfaceUPDATE 				
				******/
					if(phyState== e_floor){//i.e. when data from a previous collision is not still on the channel
							OUTCON(m_myId,  "ST->contend_backoff", "backoff ends.. reattempting contention!",3);				
							underwaterPhy.PhySendTone();	
							Idle=false;//we have gone into one of the starred states where any mac send will be blocked
							if(false==didCntd){
								didCntd=true;//we have atleast attempted reservation. now i should have greater preference
							}
							m_contendCount=1;//b/c now atleast you are contending							
							m_macState= e_mac_contention;/// change the state 
						}
						else{
							//in the case data channel is busy.. we dont check until the next slot time 
							//for protocol correctness, we go to the wait_slot state
							OUTCON(m_myId,  "ST->contention", "backoff ends.. but channel busy.. wait for next slot!",3);				
							m_macState=e_mac_wait_slot;//here we wait until the next slot to decide we want to transmit or not
							m_contendCount=0;
						}
					
				}
				else{
					//stay in this same state
					m_macState=e_mac_contend_backoff;
					OUTCON(m_myId,"ST->backoff", "bkoff remains ",4);
				}						
				OUTFILE(outFile,m_myId,"ST->backoff", "",3);
				break;
			case e_mac_contention:

				didCntd=true;
				
				if(m_firstCntdCount<m_contendCount)//this tracks the current highest value of contenders
						m_firstCntdCount=m_contendCount;
				
				if(1==m_contendCount){
					//this means we won the reservation.. still we desync our data transmission
										//set up a desyn slot 
					evInfo.eType_=e_mac_timeOut;
					evInfo.nodeId_=m_myId;
					if(true==m_macParam.hdlBiDeafness)
						evInfo.timeLeft_= (timeTicks) ( (int)(RAND_UNIFORME*DESYNC_WINDOW)*DESYNC_DURATION*SEC_TO_TIMETICK);
					else
						evInfo.timeLeft_=0;//if we are not handling deafeness, dont delay the data transmission.

					//select a desync slot to make 					
					//bi-directional deafness non-persistent
					tcbPtr = new Event(evInfo);
					hdlTimeOut=gTimerManager.AddTimer(evInfo.timeLeft_, tcbPtr);//keep the handle so that you can remove it if needed			

					m_macState=e_mac_wait_desync;
					OUTCON(m_myId,"ST->contention", "we win contention.. but we desync first",3);	
				}
				else{//we must have had other contenders.. 
					
					//now select a backoff time between 0 and the number of contenders that we had 
					//in this PSLOT
					m_slotLeft= (int)(RAND_UNIFORME*m_contendCount); //choose the backoff slot based on # of current cntd'ers
					//Note that here we still choose slots agressively while within a reservation slot
					if(0==m_slotLeft){						
						channelState phyState= underwaterPhy.getDataChannelState();
					

					/******* 
					phyInterfaceUPDATE 					
					******/
					  if(phyState == e_floor){//i.e. when data from a previous collision is not still on the channel
							OUTCON(m_myId,  "ST->contention", "No backoff .. reattempting contention!",3);				
							underwaterPhy.PhySendTone();				
							m_contendCount=1;//b/c now atleast you are contending							
							m_macState= e_mac_contention;/// change the state 
						}
						else{
							//in the case data channel is busy.. we dont check until the next slot time 
							//for protocol correctness, we go to the wait_slot state
							OUTCON(m_myId,  "ST->contention", "No backoff .. but channel busy.. wait for next slot!",3);				
							m_macState=e_mac_wait_slot;//here we wait until the next slot to decide we want to transmit or not
						}						

					}
					else{//if slotLeft>0
						//otherwise go to the bkoff state
						m_macState=e_mac_contend_backoff;
						OUTCON(m_myId,"ST->contention", "other contenders.. backing off",3);
					}					
				}								
				OUTFILE(outFile,m_myId,"ST->contention", "",3);
				break;
			case e_mac_anticipating:
			/***********
			THe idea is that only when a node is in anticipating state and 
			still doesnt hear any tone for a given PSLOT, it decrements
			the max count of slots. And these decrement only for successive
			non-conteded slots. If there is ever a contention during a PSLOT
			you invoke the ELSE where you update the slotsLeft!
			This is basically to handle any spurious tone receptions that dont result in data being transfered at all.
			CAUTION: if the first tone is false, then we have a dangerous undercounting of the # of orignal senders
			*************/
				if( 0==m_contendCount){//this means that for some very wierd reason no one has contended in the previous wait slot				
					if(m_slotLeft!=0)//but we still have to be patient
						m_slotLeft--;
					else{//no more slots to wait for left -- we have run out of patience (handle spurious tone receptions)
						if(Idle){
							m_macState= e_mac_idle;
							}
						else{///u have data to send
							//now we decide on preference based on having previously contended or not
							
							//////////////////////////////
							//Intelligent Bkoff changes - IBC /
							/////////////////////////////
							//for avg slot test
							//cout<<"start "<<globalClock.globalTime/SEC_TO_TIMETICK<<endl;
							//we decide on a back off slot duration based on the FCC
							m_slotLeft= BackOffSlot(m_firstCntdCount, didCntd,fairnessBkoff,m_framesSinceFC)+1;//+1 in this case so that we dont re attempt hastily
							OUTCON(m_myId,"ST->anticipating", "No one has attempted.. we are attempting now",3);
							//////////////////////////////
							//Intelligent Bkoff changes - IBC /
							/////////////////////////////

							}
						}
					}				
				
				else{//somebody did contend in this time period
					m_slotLeft=m_contendCount+1;

					if(m_firstCntdCount<m_contendCount)//just keep track of the best congestion status that you are aware off
						m_firstCntdCount=m_contendCount;
					
					m_contendCount=0;
				}
				
				OUTFILE(outFile,m_myId, "ST->anticipating", "",3);
				break;
			case e_mac_transmitting:
				//stay in the same state
				m_macState=e_mac_transmitting;
				OUTCON(m_myId, "ST->transmitting", "",5);
				break;
			case e_mac_receiving:
				//stay in the same state
				m_macState=e_mac_receiving;				
				OUTCON(m_myId, "ST->receiving", "",5);
				break;
			case e_mac_wait_data:
				//stay in the same state
				m_macState=e_mac_wait_data;				
				
				OUTCON(m_myId, "ST->wait_data", "",5);
				break;
			case e_mac_wait_slot:{
				channelState phyState= underwaterPhy.getDataChannelState();
				if(m_firstCntdCount<m_contendCount)//this tracks the current highest value of contenders
						m_firstCntdCount=m_contendCount;

				/******* 
				phyInterfaceUPDATE 				
				******/
				if(phyState == e_floor){//i.e. when data from a previous collision is not still on the channel
					OUTCON(m_myId,  "ST->wait_slot", "Channel not busy, sending tone",3);				
					underwaterPhy.PhySendTone();				
					m_contendCount=1;//b/c now atleast you are contending				
					Idle=false;//we have gone into one of the starred states where any mac send will be blocked

					if(false==didCntd){
						didCntd=true;//we have atleast attempted reservation. now i should have greater preference
					}
					m_macState= e_mac_contention;/// change the state 
				}
				else{
					//in the case data channel is busy.. we dont check until the next slot time 
					//for protocol correctness, we go to the wait_slot state
					m_macState=e_mac_wait_slot;//here we wait until the next slot to decide we want to transmit or not
					OUTCON(m_myId,  "ST->wait_slot", "Channel busy, attempt next time",3);				
				}

				OUTFILE(outFile,m_myId, "ST->wait_slot", "",3);
				break;
			}
			case e_mac_wait_desync:
				//this is one state in which the the ST should never occur as the timeout should move it to transmitting
				OUTCON(m_myId, "ST->wait_desync", "shouldnt happen",2);
				OUTFILE(outFile,m_myId, "ST->wait_desync", "shouldnt happen",2);
				break;

			default:
				OUTCON(m_myId, "TO->UNKNOWN STATE", "",3);
				break;
	}
	/*
	evInfo.eType_=e_mac_slotTime;
	evInfo.nodeId_=m_myId;				
			
	evInfo.timeLeft_= (timeTicks) (PSLOT_TIME*SEC_TO_TIMETICK);
	
	tcbPtr = new Event(evInfo);	
	gTimerManager.AddTimer(evInfo.timeLeft_, tcbPtr);
return false;*/
eventInformation.timeLeft_= (timeTicks) (PSLOT_TIME*SEC_TO_TIMETICK);
return true;//return true so that the same event is reinserted.. ad infinity
}
