// cSTLohi.h: interface for the cSTLohi class.
//
//////////////////////////////////////////////////////////////////////

#ifndef _STLOHI_H
#define _STLOHI_H

#include "mac.h"
#include "defines.h"

/*
#define PSLOT_TIME 	(double)(MAX_PROP_DELAY+TONE_DURATION) //the nodes are syn to multiple of this time, only 1 tone duration as there is no desyncing
#define DESYNC_DURATION 2*TONE_DURATION//this allows complete reception of tone within the deaf zone if you choose the second slot
#define INIT_SLOT_SYNC 5 ///start the slotTime events triggering after 5 ticks (just so that if saturated every one contends immediately).
*/
class cSTLohi : public cMAC  
{
public:
	short m_contendCount;///this keeps track of # of nodes contending; 
	short m_firstCntdCount;//this var keeps count of the initial # of cntdrs that attempted initially for a data phase
	short m_slotLeft;//this keeps track of the # of slots that are yet to be counted (for various purposes)
	bool dataCollided;//this is set to true when RDS happens in rx state, unset whenever going from rx to idle or contend_bkoff
	bool dataCollidedByTone;//set when we have RTS when we are in rx state, unset whenever going from rx to idle or contend_bkoff
	bool didCntd;
	short m_extraSlot;//to handle spatial unfairness when nodes are saturated. (for the transmitter)
	timeTicks lastSlotStartTime;//represents the time when the last slot started
	bool hasDeafNeighbor;//this is a flag that represents whether there is any deaf neighbor detected 
	double fairnessBkoff;//this is to handle spatial unfairness for receivers. 
	double PSLOT_TIME;
	double DESYNC_DURATION;
	double INIT_SLOT_SYNC;
	
	short m_framesSinceFC;
	cSTLohi(short Id,FILE* fptr,macParameter macParam);
	 ~cSTLohi();


	
	bool  macSend(Packet pkt);//define a pure virtual function that will be implemented by the derived classes
	
	//All these are to control the input from the simulation core loop
	bool macToneDetected(EventInfo & eventInformation) ;// phyinterfaceUPDATE
	
	bool macDataRxStart(EventInfo& eventInformation, channelState initState);
	bool macDataRxEnd(EventInfo& eventInformation, channelState initState);
	bool macDataTxEnd(EventInfo& eventInformation, channelState initState);
	bool macTimerExpire(EventInfo& eventInformation);
	bool slotTime(EventInfo& eventInformation);
	bool initSlotTime();

	bool isIdle(){ return (Idle);};

	bool resetMAC(){
		m_contendCount=m_firstCntdCount=0;
		m_slotLeft=0;
		dataCollided=dataCollidedByTone=false;
		hasDeafNeighbor=false;
		Idle= true;
		m_extraSlot=0;
		didCntd=false;
		m_pktsCollided=m_pktsCollidedByTone=m_pktsReceived=m_pktsDropped=m_pktsSent=0;
		lastSlotStartTime=0;
		underwaterPhy.resetPhy();
		m_framesSinceFC=0;
		initSlotTime();//to restart the repeated ST events
		return true;
		};
};

#endif 
