// cTDMA.cpp: implementation of the cTDMA class.
//
//////////////////////////////////////////////////////////////////////

#include "TDMA.h"

//////////////////////////////////////////////////////////////////////
// Construction/Destruction
//////////////////////////////////////////////////////////////////////

extern	cVTime globalClock;///Our global clock!
extern	Timers gTimerManager;


cTDMA::cTDMA(short Id,FILE* fptr,macParameter macParam):cMAC(Id,fptr, macParam)
{
	Idle= true;
	pktSent=false;
	pktToSend.length_=MAX_PKTLEN;
	slotDurationTDMA=(timeTicks)(((double)MAX_PKTLEN/CHANNEL_DATA_RATE)*SEC_TO_TIMETICK);
	slotDurationTDMA+=(timeTicks)((double)MAX_PROP_DELAY*SEC_TO_TIMETICK);
	//tweak the following based on how energy efficient u want the mac to be. i.e. dont call it as by default it remains on
	amPower.changeDevState( e_am_on, globalClock.globalTime);
	//the following is done if we want to assume that TDMA doesnt use WU
	wuPower.changeDevState(e_wakeup_off,globalClock.globalTime);
}

cTDMA::~cTDMA()
{

}


//the send signal in the state machine. 
bool cTDMA::macSend(Packet pkt){
if(pkt.length_ > MAX_PKTLEN){
	OUTCON(m_myId,"cTDMA::macSend","Data length bigger than MTU",2);		
	return false;

	}
	

if(Idle){
	//since this is TDMA-- set the packet to be transmitted when ur slot arrives

	
	m_currPacket=pkt;
	OUTCON(m_myId,"cTDMA::macSend","Data will be transmitted in my TDMA slot ",3);		
	Idle=false;
	pktSent=false;
	return true;
	}
	else{

		m_pktsDropped++;//otherwise we drop all packets that we had 
		return false;
	}
return true;
}



bool cTDMA::macDataRxStart(EventInfo& eventInformation, channelState initState){


//ALOHA... we should really just sleep and not be able to sense any data
return false;


}


bool cTDMA::macDataRxEnd(EventInfo& eventInformation, channelState nextState){

cMAC::macDataRxEnd(eventInformation,  nextState) ;
/*if(m_pktsReceived ==100)
	gTimerManager.flushTimerArray();//remove all array so that you can finish this soon. 
	*/	
return false;
}


bool cTDMA::macDataTxEnd(EventInfo & eventInformation, channelState initState){
TimerCallback* tcbPtr ;///pointer to insert timers for each node
EventInfo evInfo= eventInformation;

	Idle=true;//so that we can transmit again

	m_pktsSent++;
	/****
	Traffic Model: Add a call to nodeTxEnd
	****/
	evInfo.eType_=e_tx_end;
	evInfo.nodeId_=m_myId;
	evInfo.timeLeft_= (timeTicks) (0);

	tcbPtr = new Event(evInfo);

	gTimerManager.AddTimer(evInfo.timeLeft_, tcbPtr);//this should result in NodeTransmitEnd being called 
	///Traffic model input ends

return false;//for now.. unless we want to creat all event anew !
}

//The Time out event--- indicates that the TDMA slot time for the current MAC has occured. 
bool cTDMA::macTimerExpire(EventInfo & eventInformation){
if(eventInformation.eType_==e_mac_slotTime)
	return slotTime(eventInformation);//since the ST event is just a special type of timer!
return false;
}


bool cTDMA::initSlotTime(){

	TimerCallback* tcbPtr ;///pointer to insert timers for each node
	EventInfo evInfo;
	
		
	evInfo.eType_=e_mac_slotTime;
	evInfo.nodeId_=m_myId;		
	
			
	evInfo.timeLeft_= (timeTicks) (5+(slotDurationTDMA)*m_myId);
	
	tcbPtr = new Event(evInfo);	
	gTimerManager.AddTimer(evInfo.timeLeft_, tcbPtr);

	return true;
}
bool cTDMA::slotTime(EventInfo& eventInformation){
OUTCON(m_myId,"slotTime", "------",3);
if(pktSent==false && Idle==false){
	underwaterPhy.PhySendData(m_currPacket);
	pktSent=true;
}

eventInformation.timeLeft_= slotDurationTDMA*numNodes;
//Done
	return true;
}

//no tone for ALOHA

bool cTDMA::macToneDetected(EventInfo & eventInformation){

	OUTCON(m_myId,"cTDMA::macToneDetected","ERR- no tone should ever be sent/detected in TDMA",2);		

return false;

}
