// cTDMA.h: interface for the ALOHA class.
//
//////////////////////////////////////////////////////////////////////

#ifndef _TDMA_H
#define _TDMA_H

#include "mac.h"
#include "defines.h"


#define MAX_PKTLEN 81 //in ytes, what is the maximum size of data pkts that this MAC allows

class cTDMA : public cMAC  
{
public:
	
	
	bool Idle;

	Packet pktToSend;

	bool pktSent;
	timeTicks slotDurationTDMA;//this var stores the length of a TDMA slot = pktLen+max prop delay.

	
	cTDMA(short Id,FILE* fptr,macParameter macParam);
	 ~cTDMA();


	
	bool  macSend(Packet pkt);//define a pure virtual function that will be implemented by the derived classes
	
	//All these are to control the input from the simulation core loop
	bool macToneDetected(EventInfo & eventInformation) ;//phyinterfaceUPDATE
	
	bool macDataRxStart(EventInfo& eventInformation, channelState initState);
	bool macDataRxEnd(EventInfo& eventInformation, channelState initState);
	bool macDataTxEnd(EventInfo& eventInformation, channelState initState);
	bool macTimerExpire(EventInfo& eventInformation);	
	bool slotTime(EventInfo& eventInformation);
	bool initSlotTime();

	bool isIdle(){ return (Idle);};

	bool resetMAC(){
		Idle= true;
		underwaterPhy.resetPhy();	
		initSlotTime();//to restart the repeated ST events
		return true;
		};
};

#endif 
