// cUTLohi.h: interface for the cUTLohi class.
//
//////////////////////////////////////////////////////////////////////


#ifndef _UTLOHI_H
#define _UTLOHI_H

#include "mac.h"
#include "defines.h"

/***** 
Following are the UTLOHI specific defines.. 

//these TO tell you how long the MAC waits to confirm tone contention has been won..
//#define CONTEND_TO			MAX_RTT 
#define CONTEND_TO				MAX_PROP_DELAY 
#define ANTICIPATE_TO  			3*CONTEND_TO//in seconds..This is made large so that there is very little chance of incorrectly transiting to idle from anticipate state
#define MAX_RECONTEND_TIME	3*TONE_DURATION//this is the duration from which nodes with queued packets to send wait within before sending a tone
*****/
class cUTLohi : public cMAC  
{
public:
	short m_contendCount;///this keeps track of # of nodes contending
	double m_contendTimeout;
	bool dataCollided;//this is set to true when RDS happens in rx or rx_busy state, unset whenever going from rx to idle or rx_busy to contend_bkoff
	bool dataCollidedByTone;//set when we have RTS when we are in rx state, unset whenever going from rx to idle or contend_bkoff
	short m_extraSlot;//to handle fairness when nodes are saturated
	double CONTEND_TO;
	double ANTICIPATE_TO;
	double MAX_RECONTEND_TIME;
	
	static int count;
	cUTLohi(short Id,FILE* fptr,macParameter macParam);
	virtual ~cUTLohi();
	
	bool  macSend(Packet pkt);//define a pure virtual function that will be implemented by the derived classes
	
	//All these are to control the input from the simulation core loop
	bool macToneDetected(EventInfo & eventInformation); // phyinterfaceUPDATE
	
	bool macDataRxStart(EventInfo& eventInformation, channelState initState);
	bool macDataRxEnd(EventInfo& eventInformation, channelState initState);
	bool macDataTxEnd(EventInfo& eventInformation, channelState initState);
	bool macTimerExpire(EventInfo& eventInformation);

	bool isIdle(){ if(m_macState == e_mac_idle ||
					  m_macState == e_mac_anticipating|| 	
					  m_macState == e_mac_receiving)
					  return true;
				else 
					return false;
	};

	bool resetMAC(){
		m_contendCount=0;
		dataCollided=dataCollidedByTone=false;
		m_pktsCollided=m_pktsCollidedByTone=m_pktsReceived=m_pktsDropped=m_pktsSent=m_extraSlot=0;
		underwaterPhy.resetPhy();
		return true;
		};

};

#endif 
