/*
 * Author: Affan Syed <asyed@usc.edu>
 *   channel.h: The channel propagation and noise model is implemented as a shared class 
 *
 *									
 * Copyright (c) 2005 the University of Southern California.
 * All rights reserved.
 *
 * Permission to use, copy, modify, and distribute this software and its
 * documentation for any purpose, without fee, and without written agreement is
 * hereby granted, provided that the above copyright notice and the following
 * two paragraphs appear in all copies of this software.
 *
 * IN NO EVENT SHALL THE UNIVERSITY OF SOUTHERN CALIFORNIA BE LIABLE TO ANY
 * PARTY FOR DIRECT, INDIRECT, SPECIAL, INCIDENTAL, OR CONSEQUENTIAL DAMAGES
 * ARISING OUT OF THE USE OF THIS SOFTWARE AND ITS DOCUMENTATION, EVEN IF THE
 * UNIVERSITY OF SOUTHERN CALIFORNIA HAS BEEN ADVISED OF THE POSSIBILITY OF
 * SUCH DAMAGE.
 *
 * THE UNIVERSITY OF SOUTHERN CALIFORNIA SPECIFICALLY DISCLAIMS ANY WARRANTIES,
 * INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY
 * AND FITNESS FOR A PARTICULAR PURPOSE.  THE SOFTWARE PROVIDED HEREUNDER IS
 * ON AN "AS IS" BASIS, AND THE UNIVERSITY OF SOUTHERN CALIFORNIA HAS NO
 * OBLIGATION TO PROVIDE MAINTENANCE, SUPPORT, UPDATES, ENHANCEMENTS, OR
 * MODIFICATIONS.
 *
 */

#ifndef 	__CHANNEL_H
#define 	__CHANNEL_H


#include "defines.h"
#include "timers.h"


#define CHANNEL_LOSS_EXPONENT  	5 //this is the tunable parameter that sets the distance based loss of a signal
#define DEFAULT_TRANSMIT_POWER     100 //this is not the power drained but the power put on the acoustic channel in mW


class cChannel{
double MAX_RANGE;
public:
bool setMaxRange(double range){
	MAX_RANGE=range;
	return true;
	};
bool sendTone(Packet pktToSend);
bool sendData(Packet pktToSend);
EventInfo timerInfo;
};

#endif
