/* Author: Affan Syed <asyed@usc.edu>
 *   randomNumber.h:All random generation functions declared over here
 * Affan: Reference from site: http://developer.kde.org/~larrosa/otherapps.html
 * Copyright (c) 2005 the University of Southern California.
 * All rights reserved.
 *
 * Permission to use, copy, modify, and distribute this software and its
 * documentation for any purpose, without fee, and without written agreement is
 * hereby granted, provided that the above copyright notice and the following
 * two paragraphs appear in all copies of this software.
 *
 * IN NO EVENT SHALL THE UNIVERSITY OF SOUTHERN CALIFORNIA BE LIABLE TO ANY
 * PARTY FOR DIRECT, INDIRECT, SPECIAL, INCIDENTAL, OR CONSEQUENTIAL DAMAGES
 * ARISING OUT OF THE USE OF THIS SOFTWARE AND ITS DOCUMENTATION, EVEN IF THE
 * UNIVERSITY OF SOUTHERN CALIFORNIA HAS BEEN ADVISED OF THE POSSIBILITY OF
 * SUCH DAMAGE.
 *
 * THE UNIVERSITY OF SOUTHERN CALIFORNIA SPECIFICALLY DISCLAIMS ANY WARRANTIES,
 * INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY
 * AND FITNESS FOR A PARTICULAR PURPOSE.  THE SOFTWARE PROVIDED HEREUNDER IS
 * ON AN "AS IS" BASIS, AND THE UNIVERSITY OF SOUTHERN CALIFORNIA HAS NO
 * OBLIGATION TO PROVIDE MAINTENANCE, SUPPORT, UPDATES, ENHANCEMENTS, OR
 * MODIFICATIONS.
 *
 */

#ifndef _RANDNUM_H_
#define _RANDNUM_H_

#include <stdio.h>
#include <string.h>
#include <stdlib.h>
#include <math.h>


#define M_PI   3.14159265358979323846



#define RAND_UNIFORME (double)rand()/(double)RAND_MAX

double random_exp(double landa);


double random_normal(double esp,double var);

unsigned long random_poisson(double landa);

unsigned long random_binomial(unsigned long n, double p);

long double fact(unsigned long x,unsigned long f);

double hipergeom_p0(unsigned long N,unsigned long D,unsigned long n);

long random_hipergeom(unsigned long N,unsigned long D,
						unsigned long n,double p=0.0);

#endif

