/*
 * Author: Affan Syed <asyed@usc.edu>
 * simulation.h : The  simulator's skeleton
 *   
 *Description: This application creates the network, and provides the stimulus to the 
*			Network by setting a single beacon broadcast at the beacon node.This is achieved
*			using the cSimulator Class. Everything else	follows according to the 
*			state maching transition. Simulation ends when no more events are in the event queue
 *									
 * Copyright (c) 2005 the University of Southern California.
 * All rights reserved.
 *
 * Permission to use, copy, modify, and distribute this software and its
 * documentation for any purpose, without fee, and without written agreement is
 * hereby granted, provided that the above copyright notice and the following
 * two paragraphs appear in all copies of this software.
 *
 * IN NO EVENT SHALL THE UNIVERSITY OF SOUTHERN CALIFORNIA BE LIABLE TO ANY
 * PARTY FOR DIRECT, INDIRECT, SPECIAL, INCIDENTAL, OR CONSEQUENTIAL DAMAGES
 * ARISING OUT OF THE USE OF THIS SOFTWARE AND ITS DOCUMENTATION, EVEN IF THE
 * UNIVERSITY OF SOUTHERN CALIFORNIA HAS BEEN ADVISED OF THE POSSIBILITY OF
 * SUCH DAMAGE.
 *
 * THE UNIVERSITY OF SOUTHERN CALIFORNIA SPECIFICALLY DISCLAIMS ANY WARRANTIES,
 * INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY
 * AND FITNESS FOR A PARTICULAR PURPOSE.  THE SOFTWARE PROVIDED HEREUNDER IS
 * ON AN "AS IS" BASIS, AND THE UNIVERSITY OF SOUTHERN CALIFORNIA HAS NO
 * OBLIGATION TO PROVIDE MAINTENANCE, SUPPORT, UPDATES, ENHANCEMENTS, OR
 * MODIFICATIONS.
 *
 */

#ifndef 	__SIMULATOR_H
#define 	__SIMULATOR_H
#include "simNode.h"



//The following class sets up the simulation. 
// The simulation can be initiated by the start funciton

class cSimulator {

public:
	cSimulator(string directory): directory_(directory){nodeCount =0;};
	~cSimulator(){
		fclose(fptr);
	};
	bool Initialize(string cfgFileName, double range, double frac);///parse the conf file ans set up simulation params
	void AddNode(Coordinate location, macParameter macParams,short nodeId, FILE*  fptr, trafficInfo trafficRate);//to manually add nodes
	void SimStart();///used to give the stimuli to run the simulation
	void EventLoop();//run through all possible events
	timeTicks MAX_SIMTIME;
	FILE* fptr;	
private:

	
	double simTimeInSec;
	int nodeCount;//to keep the count of number of nodes present
	string directory_;
	int beaconId;//keep track of the beacon id for providing the stimulus
	cNode* nodeCreator;//ptr that we use to create a new object and assign to the vector 
	

};

#endif
