// cALOHA.cpp: implementation of the cSALOHA class.
//
//////////////////////////////////////////////////////////////////////

#include "slottedAloha.h"

//////////////////////////////////////////////////////////////////////
// Construction/Destruction
//////////////////////////////////////////////////////////////////////

extern	cVTime globalClock;///Our global clock!
extern	Timers gTimerManager;


cSALOHA::cSALOHA(short Id,FILE* fptr,macParameter macParam):cMAC(Id,fptr, macParam)
{
	
	pktSent=false;
	pktToSend.length_=PKTLEN;

	//tweak the following based on how energy efficient u want the mac to be. i.e. dont call it as by default it remains on
	amPower.changeDevState( e_am_on, globalClock.globalTime);
	//the following is done if we want to assume that TDMA doesnt use WU
	wuPower.changeDevState(e_wakeup_off,globalClock.globalTime);
}

cSALOHA::~cSALOHA()
{

}


//the send signal in the state machine. 
bool cSALOHA::macSend(Packet pkt){
if(Idle){
	//since it slotted ALOHA -- set the packet to be transmitted at the start of next slot

	m_currPacket=pkt;
	OUTCON(m_myId,"cALOHA::macSend","Data to be transmitted at next slot beggining",3);		
	Idle=false;
	pktSent=false;
	return true;
	}
	else{

		m_pktsDropped++;
		return false;
	}
return true;
}



bool cSALOHA::macDataRxStart(EventInfo& eventInformation, channelState initState){


//ALOHA... we should really just sleep and not be able to sense any data
return false;


}


bool cSALOHA::macDataRxEnd(EventInfo& eventInformation, channelState nextState){

		 cMAC::macDataRxEnd( eventInformation,  nextState) ;
/*if(m_pktsReceived ==100)
	gTimerManager.flushTimerArray();//remove all array so that you can finish this soon. 
	*/	

return false;
}


bool cSALOHA::macDataTxEnd(EventInfo & eventInformation, channelState initState){
TimerCallback* tcbPtr ;///pointer to insert timers for each node
EventInfo evInfo= eventInformation;

	Idle=true;//so that we can transmit again

	m_pktsSent++;
	/****
	Traffic Model: Add a call to nodeTxEnd
	****/
	evInfo.eType_=e_tx_end;
	evInfo.nodeId_=m_myId;
	evInfo.timeLeft_= (timeTicks) (0);

	tcbPtr = new Event(evInfo);

	gTimerManager.AddTimer(evInfo.timeLeft_, tcbPtr);//this should result in NodeTransmitEnd being called 
	///Traffic model input ends

return false;//for now.. unless we want to creat all event anew !
}

//The Time out event
bool cSALOHA::macTimerExpire(EventInfo & eventInformation){
if(eventInformation.eType_==e_mac_slotTime)
	return slotTime(eventInformation);//since the ST event is just a special type of timer!
return false;
}


bool cSALOHA::initSlotTime(){

	TimerCallback* tcbPtr ;///pointer to insert timers for each node
	EventInfo evInfo;

		
	evInfo.eType_=e_mac_slotTime;
	evInfo.nodeId_=m_myId;				
			
	evInfo.timeLeft_= (timeTicks) (5);
	
	tcbPtr = new Event(evInfo);	
	gTimerManager.AddTimer(evInfo.timeLeft_, tcbPtr);

	return true;
}
bool cSALOHA::slotTime(EventInfo& eventInformation){
OUTCON(m_myId,"slotTime", "------",3);
if(pktSent==false && Idle==false){
	underwaterPhy.PhySendData(m_currPacket);
	pktSent=true;
}

eventInformation.timeLeft_= (timeTicks) ( ((pktToSend.length_/CHANNEL_DATA_RATE)+m_macParam.fracDelay*MAX_PROP_DELAY)*SEC_TO_TIMETICK+1);
	return true;
}

//no tone for ALOHA

bool cSALOHA::macToneDetected(EventInfo & eventInformation){

	OUTCON(m_myId,"cALOHA::macToneDetected","ERR- no tone should ever be sent/detected in ALOHA",2);		

return false;

}
