/*
 * Author: Affan Syed <asyed@usc.edu>
 * testSimulation.cpp : Here we test the simulator with different inputs
 *   
 *Description: Just provide the required inputs to the simulator class so that we can start our simulations. 
 *									
 * Copyright (c) 2005 the University of Southern California.
 * All rights reserved.
 *
 * Permission to use, copy, modify, and distribute this software and its
 * documentation for any purpose, without fee, and without written agreement is
 * hereby granted, provided that the above copyright notice and the following
 * two paragraphs appear in all copies of this software.
 *
 * IN NO EVENT SHALL THE UNIVERSITY OF SOUTHERN CALIFORNIA BE LIABLE TO ANY
 * PARTY FOR DIRECT, INDIRECT, SPECIAL, INCIDENTAL, OR CONSEQUENTIAL DAMAGES
 * ARISING OUT OF THE USE OF THIS SOFTWARE AND ITS DOCUMENTATION, EVEN IF THE
 * UNIVERSITY OF SOUTHERN CALIFORNIA HAS BEEN ADVISED OF THE POSSIBILITY OF
 * SUCH DAMAGE.
 *
 * THE UNIVERSITY OF SOUTHERN CALIFORNIA SPECIFICALLY DISCLAIMS ANY WARRANTIES,
 * INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY
 * AND FITNESS FOR A PARTICULAR PURPOSE.  THE SOFTWARE PROVIDED HEREUNDER IS
 * ON AN "AS IS" BASIS, AND THE UNIVERSITY OF SOUTHERN CALIFORNIA HAS NO
 * OBLIGATION TO PROVIDE MAINTENANCE, SUPPORT, UPDATES, ENHANCEMENTS, OR
 * MODIFICATIONS.
 *
 */
 #include "simulation.h"
 
#define MAX_NUM_NODES 8


void GenTopology(cSimulator& sim, macParameter mParam, trafficInfo traffic,short numNodes,bool isRandom){
Coordinate location;
short nodeId;
float fixedTopology[MAX_NUM_NODES][2]={		//node Id
										{0,0},// 1 =A
									   // {(MAX_RANGE/2)+10,0},// 2 = B
									//	{(MAX_RANGE/3), 0},//  3 = C
										{0,270},// 4
										{0,270},// 4
										{0,270},// 4
										{120,150},// 5
										{240,150},// 6
										{390,270},// 7
										{390,30}// 8
									   };
	if(isRandom){
		for(nodeId=0;nodeId<numNodes;nodeId++){
			
			/*** For Random topology***/
			location.x=RAND_UNIFORME*MAX_X;
			location.y=RAND_UNIFORME*MAX_Y;

			//**/
			sim.AddNode(location, mParam, nodeId,sim.fptr , traffic);///the arrival rate we are not going to use anyway!
		}
	}
	else{
		for(nodeId=0;nodeId<numNodes;nodeId++){
		
			location.x=fixedTopology[nodeId][0];
			location.y=fixedTopology[nodeId][1];

		
			sim.AddNode(location, mParam, nodeId,sim.fptr , traffic);///the arrival rate we are not going to use anyway!
		}
	}
}


int main(int argc, char* argv[]){
	
	string ioDirectory ="./";
	
	string outFileName= ioDirectory+"trace.out";
	
	
	if (argc <4) {
			 cout << "usage: ./UWSimulator  <cfgFile> <range> <rangeFrac>\n"
				  << "\n In-correct number of arguments to simulation\n"
				  << endl;
			return 0;
			};
	
	string cfgFile = argv[1];
	double range=atof(argv[2]);
	double frac= atof(argv[3]);
	cSimulator simulator(ioDirectory);

	simulator.fptr= fopen(outFileName.c_str(),"w+");//for writing to the output. 
	simulator.Initialize(cfgFile,range,frac);


	simulator.SimStart();//start the simulation with the requiste poisson traffic model
	
	
	return 1;
}
